Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.jxpath
Interface Pointer

All Superinterfaces:
  java.lang.Cloneable, java.lang.Comparable, java.io.Serializable

All Known Implementing Classes:
  NodePointer

public interface Pointer
extends java.lang.Cloneable, java.lang.Comparable, java.io.Serializable

Pointers represent locations of objects and their properties in Java object graphs. JXPathContext has methods (`getPointer()` and (`iteratePointers()`, which, given an XPath, produce Pointers for the objects or properties described the the path. For example, `ctx.getPointer ("foo/bar")` will produce a Pointer that can get and set the property "bar" of the object which is the value of the property "foo" of the root object. The value of `ctx.getPointer("aMap/aKey[3]")` will be a pointer to the 3'rd element of the array, which is the value for the key "aKey" of the map, which is the value of the property "aMap" of the root object.

Version:
  $Revision: 1.7 $ $Date: 2003/03/11 00:59:12 $
Author:
  Dmitri Plotnikov

Method Summary
`java.lang.String` | `asPath()` Returns a string that is a proper "canonical" XPath that corresponds to this pointer.
`java.lang.Object` | `clone()` Pointers are cloneable
`java.lang.Object` | `getNode()` Returns the raw value of the object, property or collection element this pointer represents.
`java.lang.Object` | `getRootNode()` Returns the node this pointer is based on.
`java.lang.Object` | `getValue()` Returns the value of the object, property or collection element this pointer represents.
`void` | `setValue(java.lang.Object value)` Modifies the value of the object, property or collection element this pointer represents.

Methods inherited from interface java.lang.Comparable
`compareTo`

Method Detail

### getValue

    public java.lang.Object getValue()

  Returns the value of the object, property or collection element this pointer represents. May convert the value to one of the canonical InfoSet types: String, Number, Boolean, Set. For example, in the case of an XML element, getValue() will return the text contained by the element rather than the element itself.

### getNode

    public java.lang.Object getNode()

  Returns the raw value of the object, property or collection element this pointer represents. Never converts the object to a canonical type: returns it as is. For example, for an XML element, getNode() will return the element itself rather than the text it contains.

### setValue

    public void setValue(java.lang.Object value)

  Modifies the value of the object, property or collection element this pointer represents.

### getRootNode

    public java.lang.Object getRootNode()

  Returns the node this pointer is based on.

### asPath

    public java.lang.String asPath()

  Returns a string that is a proper "canonical" XPath that corresponds to this pointer. Consider this example:

  `Pointer ptr = ctx.getPointer("//employees[firstName = 'John']")`

  The value of `ptr.asPath()` will look something like `"/departments[2]/employees[3]"`, so, basically, it represents the concrete location(s) of the result of a search performed by JXPath. If an object in the pointer's path is a Dynamic Property object (like a Map), the asPath method generates an XPath that looks like this: `" /departments[@name = 'HR']/employees[3]"`.

### clone

    public java.lang.Object clone()

  Pointers are cloneable
  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2003 Apache Software Foundation. All Rights Reserved.